<?php

// XValidate.class.php
//
// $Id: XValidate.class.php 1424 2008-12-29 16:09:36Z tim $
//
// (c)2003-2005 Tim Jackson (tim@timj.co.uk)
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.
// 
// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

define('XVALIDATE_UNDELIVERABLE',1);
define('XVALIDATE_TEMPERR',2);
define('XVALIDATE_SYNTAXERR',3);
define('XVALIDATE_OK',4);

// Set this to empty if you don't want to use Exim to validate e-mail addresses
define('XVALIDATE_EMAIL_COMMAND','/usr/sbin/exim -bt');

class XValidate {
	
	function Email ($email) {
		if (!strstr($email,'@')) return XVALIDATE_SYNTAXERR;
		if (preg_match("/@.*@/",$email)) return XVALIDATE_SYNTAXERR;
		if (strstr($email,',')) return XVALIDATE_SYNTAXERR;
		
		$Cmd = XVALIDATE_EMAIL_COMMAND;
		if (!empty($Cmd)) {
			$Command = XVALIDATE_EMAIL_COMMAND.' '.escapeshellarg($email);
			$ProcDescriptor = array(
				1 => array('pipe', 'w'),	// stdout
				2 => array('pipe', 'w'),	// stderr
			);
			$Proc = proc_open($Command,$ProcDescriptor,$Pipes);
			if (is_resource($Proc)) {
				$CmdOutputOK = '';
				$CmdOutputErr = '';
				while(!feof($Pipes[1])) {
					$CmdOutputOK .= fgets($Pipes[1], 1024);
				}
				fclose($Pipes[1]);
				while(!feof($Pipes[2])) {
					$CmdOutputErr .= fgets($Pipes[2], 1024);
				}
				fclose($Pipes[2]);
				$RetVal = proc_close($Proc);
				switch($RetVal) {
					case 0:
						return XVALIDATE_OK;
						break;
					case 1:
						return XVALIDATE_TEMPERR;
						break;
					case 2:
						if (!empty($CmdOutputOK)) {
							if (stristr($CmdOutputOK,'syntax error')) return XVALIDATE_SYNTAXERR;
						}
						return XVALIDATE_UNDELIVERABLE;
						break;
					default:
						trigger_error("E-mail validation warning - return status $RetVal : [stdout] $CmdOutputOK, [stderr] $CmdOutputErr (command was: $Command)",E_USER_WARNING);
						return XVALIDATE_TEMPERR;
				}
				/*
				if (stristr($CmdOutputOK,'is undeliverable'))  return XVALIDATE_UNDELIVERABLE;
				
				if (stristr($CmdOutputOK,'cannot be resolved at this time')) return XVALIDATE_TEMPERR;
				return XVALIDATE_OK;*/
			} else {
				trigger_error('E-mail validation error: could not open proc',E_USER_ERROR);
				return XVALIDATE_TEMPERR;
			}
		} else {
			// Not running Exim
			return XVALIDATE_OK;
		}
		return XVALIDATE_TEMPERR;
	}
}